package com.webonlineapp.hyjavachartsdemo8.examplecharts;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.common.GenericOption;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.XAxis;
import com.hyjavacharts.model.highcharts.YAxis;
import com.hyjavacharts.model.highcharts.constants.AxisType;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.series.SeriesBar;
import com.hyjavacharts.model.highcharts.series.seriesbar.Zones;
import com.webonlineapp.hyjavachartsdemo8.charts.DemoChartBase;
import com.webonlineapp.hyjavachartsdemo8.services.RestService;

public class RealtimeSorting extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
	    
		chartOptions.getChart().setType(ChartType.BAR).setMarginLeft(100);
		chartOptions.getTitle().setText("Bar series - data sorting");
	
		YAxis yAxi = new YAxis();
		yAxi.getTitle().setText("");
		chartOptions.getYAxis().add(yAxi);
		
		XAxis xAxi = new XAxis();
		xAxi.setType(AxisType.CATEGORY).setMin(0);
		xAxi.getLabels().get_genericOption().add(new GenericOption("animate", "true"));
		chartOptions.getXAxis().add(xAxi);
	
		chartOptions.getLegend().setEnabled(false);

		SeriesBar seriesBar = new SeriesBar();
		seriesBar.setZoneAxis("x").getZones().add(new Zones().setValue(1).setColor(new Color("#ff4d40")));
		seriesBar.getDataLabels().setEnabled(true).setFormat("{y:,.2f}");
		seriesBar.getDataSorting().setEnabled(true).setSortKey("y");
		chartOptions.getSeries().add(seriesBar);
		
		chartOptions.getData().setCsvURL(RestService.getURI() + "/RealtimeSortingCSVData")
			.setEnablePolling(true)
			.setDataRefreshRate(3);

		return highChart;
	}
	
}
