package com.webonlineapp.gwtdemo.server;

import java.util.HashMap;
import java.util.Map;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;
import com.hyjavacharts.chart.Highchart;
import com.hyjavastock.chart.Highstock;
import com.webonlineapp.gwtdemo.client.ChartService;

/**
 * The server-side implementation of the RPC service.
 */
@SuppressWarnings("serial")
public class ChartServiceImpl extends RemoteServiceServlet implements ChartService {

	/**
	 * Return global and chart js options
	 */
	public Map<String, String> getChartOptions(String chartName) throws IllegalArgumentException {
		Map<String, String> optionsMap = new HashMap<String, String>();
		String globalOptions = "";
		String chartOptions = "";

		if (chartName.equals("Highstock Column")) {
			optionsMap.put("chartType", "highstock");
			Highstock hs = new HighstockColumn().configure();
			chartOptions = hs.chartOptionsToJs();
		} 
		else {
			Highchart hc = null;
			optionsMap.put("chartType", "highcharts");

			if (chartName.equals("Highcharts Line")) {
				hc = new HighchartsLine().configure();
				chartOptions = hc.chartOptionsToJs();
			} else {
				hc = new HighchartsPie().configure();
				chartOptions = hc.chartOptionsToJs();
			}
		}
		
		optionsMap.put("globalOptions", globalOptions);
		optionsMap.put("chartOptions", chartOptions);

		return optionsMap;
	}

}
